<?php

/** ----------------------------------------------------------------------------
 *
 * product_reviews_write.php
 *
 * WEB-Shop Software http://www.webs.de/
 *
 * Customers can write reviews.
 *
 * -----------------------------------------------------------------------------
 * based on:
 *  (c) 2000-2001 The Exchange Project (earlier name of osCommerce)
 *  (c) 2002-2003 osCommerce; www.oscommerce.com
 *  (c) 2003 nextcommerce; www.nextcommerce.org
 *  (c) 2006 XT-Commerce
 *
 * Released under the GNU General Public License
 *
 * @version $Id: product_reviews_write.php 2181 2011-09-27 18:16:16Z DocOlson $
 * @copyright 2011 WEB-Shop Software http://www.webs.de/
 *
 * -----------------------------------------------------------------------------
 */

include ('includes/application_top.php');
$smarty = new template();
$smarty->caching = 0;

require (DIR_FS_CATALOG.'templates/'.CURRENT_TEMPLATE.'/source/boxes.php');

if ( $_SESSION['customers_status']['customers_status_write_reviews'] == 0 ) {
	xtc_redirect(xtc_href_link(FILENAME_LOGIN, '', 'SSL'));
}

if (isset ($_GET['action']) && $_GET['action'] == 'process') {

	// We got to the process but it is an illegal product, don't write
	if (is_object($product) && $product->isProduct()) {

		$error = false;

		if ( strlen($_POST['review']) < REVIEW_TEXT_MIN_LENGTH ) {
			$error = true;
			$messageStack->add(sprintf(REVIEW_TEXT, REVIEW_TEXT_MIN_LENGTH));
		}

		if ( !isset($_POST['rating']) ) {
			$error = true;
			$messageStack->add(REVIEW_RATING);
		}

		if ($error === false) {

			$author = trim($_POST['author']);
			$author = empty($author) ? TEXT_GUEST : mysql_real_escape_string($author);

			xtc_db_query(sprintf('-- product_reviews_write insert
				INSERT INTO %s
				SET
					products_id = "%u",
					customers_id = "%u",
					customers_name = "%s",
					reviews_rating = "%s",
					date_added = NOW(),
					reviews_status = "%u"',
				TABLE_REVIEWS, $product->data['products_id'], $_SESSION['customer_id'],
				$author,
				mysql_real_escape_string($_POST['rating']), REVIEW_STATUS == 'True' ? 1 : 0
                        ));
			$reviewId = xtc_db_insert_id();
			xtc_db_query(sprintf('-- product_reviews_write insert language
				INSERT INTO %s
				SET
					reviews_id = "%u",
					languages_id = "%u",
					reviews_text = "%s"',
				TABLE_REVIEWS_DESCRIPTION, $reviewId, $_SESSION['languages_id'],
				mysql_real_escape_string($_POST['review'])
			));
		}
	}

	if ($error === false) {
		$link = xtc_href_link(FILENAME_PRODUCT_REVIEWS, $_POST['get_params']);
		if (isset($reviewId) and REVIEW_STATUS == 'False') {
			$link .= (strpos($link, '?') === false ? '?' : '&amp;').'reviews_id='.$reviewId;
		}
		xtc_redirect($link);
	}
}

// lets retrieve all $HTTP_GET_VARS keys and values..
$get_params = xtc_get_all_get_params();
$get_params_back = xtc_get_all_get_params(array('reviews_id')); // for back button
$get_params = ecb_substr($get_params, 0, -1); //remove trailing &

if (xtc_not_null($get_params_back)) {
	$get_params_back = ecb_substr($get_params_back, 0, -1); //remove trailing &
} else {
	$get_params_back = $get_params;
}

$breadcrumb->add(NAVBAR_TITLE_REVIEWS_WRITE, xtc_href_link(FILENAME_PRODUCT_REVIEWS, $get_params));

$res = xtc_db_query(sprintf(
	"SELECT customers_firstname, customers_lastname
	FROM %s WHERE customers_id = '%u'",
	TABLE_CUSTOMERS, $_SESSION['customer_id']
));
$customer_info = xtc_db_fetch_array($res);

if (!$product->isProduct()) {
	$messageStack->add(ERROR_INVALID_PRODUCT);
} else {
	$name = $customer_info['customers_firstname'].' '.$customer_info['customers_lastname'];

	if ( isset($_POST['review']) ) {
		$rev = ini_get('magic_quotes_gpc') == 1
			 ? stripslashes($_POST['review'])
			 : $_POST['review'];
	}

	if ($name == ' ') {
		$customer_info['customers_lastname'] = TEXT_GUEST;
	}

	$smarty->assign('PRODUCTS_NAME', $product->data['products_name']);
	$smarty->assign('AUTHOR', $customer_info['customers_firstname'].' '.$customer_info['customers_lastname'] . '.');

	$smarty->assign(
		'INPUT_AUTHOR',
		xtc_draw_input_field(
			'author',
			$customer_info['customers_firstname'].' '.$customer_info['customers_lastname']
		)
	);
	$smarty->assign('INPUT_TEXT', xtc_draw_textarea_field('review', 'soft', 60, 15, $rev, '', false));
	$smarty->assign('OLD_INPUT_TEXT', $rev);

	$rating = array();

	for ( $i = 1; $i <= 5; $i++ ) {
		$checked = $i == $_POST['rating'] ? true : false;
		$rating[] = xtc_draw_radio_field('rating', $i, $checked);
	}

	$smarty->assign('INPUT_RATING', implode('', $rating));
	$smarty->assign('INPUT_RATING_ARRAY', $rating);

	$smarty->assign(
		'FORM_ACTION',
		xtc_draw_form(
			'form_product_reviews_write',
			xtc_href_link(
				FILENAME_PRODUCT_REVIEWS_WRITE,
				'action=process&'.xtc_product_link(
					$product->data['products_id'],
					$product->data['products_name']
				)
			),
			'post'
		)
	);

	$smarty->assign(
		'BUTTON_BACK',
		'<a href="javascript:history.back(1)">'.xtc_image_button('button_back.gif', IMAGE_BUTTON_BACK).'</a>'
	);

	$smarty->assign(
		'BUTTON_SUBMIT',
		xtc_image_submit(
			'button_continue.gif',
			IMAGE_BUTTON_CONTINUE).xtc_draw_hidden_field('get_params', $get_params)
	);
	$smarty->assign('MIN_LENGTH_INFO', sprintf(REVIEW_TEXT, REVIEW_TEXT_MIN_LENGTH));
	$smarty->assign('MIN_LENGTH', REVIEW_TEXT_MIN_LENGTH);
	$smarty->assign('FORM_END', '</form>');
}

$main_content = $smarty->fetch('module/product_reviews_write.html');
include ('includes/application_bottom.php');
